// Original code by TAKAHASHI Shuhei <pcb@pcbsoft.net>
// This code is licensed under NYSL ver. 0.9982.
// See LICENSE.txt for details.

#include "common.h"




// IPAhX񂩂ǂ`FbN
//		p1	IPAhX
EXPORT BOOL WINAPI isip(BMSCR *bm, char *p1, int p2, int p3)
{
	struct sockaddr_storage addr;
	int addrlen;
	unsigned long u;

	addrlen = sizeof(addr);
	if (WSAStringToAddress(p1, AF_INET6, NULL, (struct sockaddr *)&addr, &addrlen) != SOCKET_ERROR) {
		if (IN6_IS_ADDR_MULTICAST(&((struct sockaddr_in6 *)&addr)->sin6_addr))
			return -3;	// }`LXgAhX
		if (IN6_IS_ADDR_SITELOCAL(&((struct sockaddr_in6 *)&addr)->sin6_addr))
			return -2;	// vCx[gAhX
		return -1;	// ʃAhX
	}

	addrlen = sizeof(addr);
	if (WSAStringToAddress(p1, AF_INET, NULL, (struct sockaddr *)&addr, &addrlen) != SOCKET_ERROR) {
		u = ntohl(((struct sockaddr_in *)&addr)->sin_addr.s_addr);
		if ((0x0a000000<=u && u<=0x0affffff) || (0xac100000<=u && u<=0xac1fffff) || (0xc0a80000<=u && u<=0xc0a8ffff))
			return -2;	// vCx[gAhX
		if (0xe0000000<=u && u<=0xefffffff)
			return -3;	// }`LXgAhX
		return -1;	// ʃAhX
	}
	return 0;	// IPAhX
}


// [J}VIPAhX擾
//		p1	ϐ
EXPORT BOOL WINAPI ownip(char *p1, int p2, int p3, int p4)
{
	*p1 = '\0';
	if (! bInit) return -1;		// WinSockG[

	char name[256];
	HOSTENT *pEnt;
	IN_ADDR in;

	if ( gethostname(name, sizeof(name)) == SOCKET_ERROR )
		return -2;	// zXg擾s

	pEnt = gethostbyname(name);
	in.s_addr = *(unsigned long *)pEnt->h_addr_list[0];
	strcpy(p1, inet_ntoa(in));
	return 0;
}






// \PbgB\Pbg̎ʂ̋ʖ
//		p1	\Pbgnh
EXPORT BOOL WINAPI netclose(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_ALL))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg
	DeleteSocket(si);
	return 0;
}



// G[R[h擾B\Pbg̎ʂ̋ʖ
//		p1	G[R[hϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI neterror(int *p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p2;
	*p1 = 0;
	if (! IsSocket(si, ST_ALL))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg
	si->Lock();
	*p1 = si->err;
	si->Unlock();
	return 0;
}



// \Pbgł邩H
//		p1	\Pbgnh
EXPORT BOOL WINAPI netfail(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;

	if (! IsSocket(si, ST_ALL))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -3;	// \Pbg

	int err = si->err;

	if (err == 0) return 0;	// G[Ȃ
	else if (err == WSAESHUTDOWN || err == WSAEDISCON) return -1;	// N[Y
	else return -2;	// N[Yς
}






// Lȃ\Pbg`FbN
//		p1	\Pbgnh
EXPORT BOOL WINAPI issocket(int p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p1, ST_ALL))
		return -1;	// \Pbg
	return 0;	// \Pbg
}

// \Pbǧȃ`FbNv
//		No param.
EXPORT BOOL WINAPI netstrict(int p1, int p2, int p3, int p4)
{
	bStrict = TRUE;
	return 0;
}

// \Pbǧȃ`FbNvȂ
//		No param.
EXPORT BOOL WINAPI netsilent(int p1, int p2, int p3, int p4)
{
	bStrict = FALSE;
	return 0;
}

// obt@̍ő咷w
//		p1	ő咷(64)[MB]
EXPORT BOOL WINAPI netbuffer(int p1, int p2, int p3, int p4)
{
	if (p1 < 0) return -1;	// ͈͊O
	if (p1 == 0) p1 = 4;
	iMaxBuffer = p1*1024*1024;
	return 0;
}

/*
// TCPconfiguration ݒ
//		p1	TCPMobt@TCY(4096)
//		p1	TCPMobt@TCY(16*1024)
// @@obsolute
EXPORT BOOL WINAPI tcpconf(int p1, int p2, int p3, int p4)
{
	if (! ss.empty())
		return -1;		// rŕύXȂI
	if (p1 <= 0) p1 = 4096;
	if (p2 <= 0) p2 = 16*1024;
	iTCPSendBuf = p1;
	iTCPRecvBuf = p2;
	return 0;
}
*/







// pcbnet
//		B
EXPORT BOOL WINAPI netinit(int p1, int p2, int p3, int p4)
{
	if (Initialize())
		return -1;
	DestroySocketSet();
	return 0;
}



// pcbnet
//		B
EXPORT BOOL WINAPI netbye(int p1, int p2, int p3, int p4)
{
	Cleanup();
	return 0;
}







