// Original code by TAKAHASHI Shuhei <pcb@pcbsoft.net>
// This code is licensed under NYSL ver. 0.9982.
// See LICENSE.txt for details.

#include "common.h"
#include "general.h"


//	PING\Pbg쐬AECHONGXg𑗐M
//		p1	\Pbgnhi[ϐ
//		p2	MzXg
//		p3	^CAEg
//		p4	TTL
EXPORT BOOL WINAPI pingsend(int *p1, char *p2, int p3, int p4)
{
	*p1 = 0;
	if (Initialize()) return -1;		// WinSockG[

	if (p3 == 0)
		p3 = 3000;
	if (p4 == 0)
		p4 = 255;
	if (p3 < 0 || p4 < 0 || p3 > 60000 || p4 > 255)
		return -3;

	SOCKETINFO *si;

	si = CreateSocket(ST_PING);
	if (si == NULL)
		return -2;			//	SocketG[

	si->Lock();
	getstr(si->ping.hostname, p2, sizeof(si->ping.hostname));
	si->ping.iTimeOut = p3;
	si->ping.TTL = (unsigned char)p4;

	PostMessage(si->hWnd, WM_PCBNET_PING, 0, 0);

	si->Unlock();

	*p1 = (int)si;
	return 0;
}


//	`FbN
//		p1	\PbgID
EXPORT BOOL WINAPI pingcheck(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_PING))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -3;	// \Pbg

	int ret;

	si->Lock();
	if (! si->ping.bResult) {
		ret = 0;	// ^CAEgĂȂ
	}
	else if (si->ping.replycode == ICMP_REPLY) {
		ret = -1;	// 탊vC
	}
	else {
		ret = -2;	// G[
	}
	si->Unlock();
	return ret;
}



//	hostaddr擾
//		p1	ʂi[鐔lϐ
//		p2	\PbgID
//		refstr	ԂėzXgIP
EXPORT BOOL WINAPI pingresult(int *p1, int p2, int p3, char *refstr)
{
	*p1 = 0;
	refstr[0] = '\0';
	SOCKETINFO *si = (SOCKETINFO *)p2;
	if (! IsSocket(si, ST_PING))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;	// \Pbg

	if (! si->ping.bResult) return -1;	// ^CAEgĂȂ
	if (si->err != 0) {
		*p1 = -4;
		return 0;
	}

	char tmp[128];

	si->Lock();
	
	if (si->ping.replycode != ICMP_NOREPLY) {
		if (getnameinfo((struct sockaddr *)&si->ping.fromaddr, si->ping.fromaddrlen, tmp, sizeof(tmp), NULL, 0, NI_NUMERICHOST) == 0)
			strcpy(refstr, tmp);
	}

	if (si->ping.replycode == ICMP_REPLY) {
		*p1 = (int)si->ping.iTripTime;
	}
	else if (si->ping.replycode == ICMP_NOREPLY) {
		*p1 = -1;
	}
	else if (si->ping.replycode == ICMP_UNREACHED) {
		*p1 = -2;
	}
	else if (si->ping.replycode == ICMP_TTL) {
		*p1 = -3;
	}
	else {
		*p1 = -4;
	}

	si->Unlock();
	return 0;
}


EXPORT BOOL WINAPI pingclose(int p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p1, ST_PING))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;
	return netclose(p1, p2, p3, p4);
}

