// Original code by TAKAHASHI Shuhei <pcb@pcbsoft.net>
// This code is licensed under NYSL ver. 0.9982.
// See LICENSE.txt for details.

#include "common.h"
#include "general.h"


// TCP\Pbg쐬Aڑ
//		p1	\Pbgnhi[ϐ
//		p2	ڑT[o[
//		p3	ڑ|[g
EXPORT BOOL WINAPI tcpopen(int *p1, char *p2, int p3, int p4)
{
	*p1 = 0;
	if (! bInit) return -1;			// WinSockG[

	/*  `FbN  */
	if (p3 <= 0 || p3 >= 65536) return -3;	// |[gԍ͈͊O

	SOCKETINFO *si;
	si = CreateSocket(ST_TCP);
	if (si == NULL)
		return -2;			//	SocketG[

	SendMessage(si->hWnd, WM_PCBNET_CONNECT, (WPARAM)p3, (LPARAM)p2);
	*p1 = (int)si;
	return 0;
}




// TCP\Pbgڑς݂ǂ擾
//		p1	\Pbgnh
EXPORT BOOL WINAPI tcpiscon(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -3;	// \Pbg

	int ret;

	si->Lock();
	if ( si->tcp.bSendable && si->err == 0 )
		ret = -1;		//	ڑς
	else if ( si->err != 0 )
		ret = -2;		//	ڑς
	else
		ret = 0;		//	ڑ
	si->Unlock();

	return ret;
}




// TCP\PbgRead
//		p1	ϐ
//		p2	ItZbg
//		p3	őMTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI tcprecv(char *p1, int p2, int p3, int p4)
{
	int n;
	SOCKETINFO *si = (SOCKETINFO *)p4;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return 0;	// \Pbg

	/*  `FbN  */
	if (p2 < 0 || p3 < 0) return 0;

	si->Lock();
	n = si->tcp.r->Read(p1+p2, p3);
	if (si->tcp.bReadPending)
		PostMessage(si->hWnd, WM_PCBNET_ASYNC, (WPARAM)si->soc[0], WSAMAKESELECTREPLY(FD_READ, 0));
	si->Unlock();
	return -n;
}


// TCP\PbgPeek
//		p1	ϐ
//		p2	ItZbg
//		p3	őMTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI tcppeek(char *p1, int p2, int p3, int p4)
{
	int n;
	SOCKETINFO *si = (SOCKETINFO *)p4;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return 0;	// \Pbg

	/*  `FbN  */
	if (p2 < 0 || p3 < 0) return 0;

	si->Lock();
	n = si->tcp.r->Peek(p1+p2, p3);
	si->Unlock();
	return -n;
}


// TCP\PbgWrite
//		p1	ϐ
//		p2	ItZbg
//		p3	MTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI tcpsend(char *p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p4;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -4;	// \Pbg

	/*  `FbN  */
	if (p2 < 0 || p3 < 0) return -3;

	si->Lock();
	if (! si->tcp.bSendable) {
		si->Unlock();
		return -2;	// ڑ؂Ă
	}
	if (si->tcp.bShutting) {
		si->Unlock();
		return -1;	// shutdownς
	}
	si->tcp.s->Write(p1+p2, p3);
	si->Unlock();
	PostMessage(si->hWnd, WM_PCBNET_SENDING, 0, 0);
	return 0;
}


// TCP\PbgCount(r)
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpcount(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	SOCKETINFO *si = (SOCKETINFO *)p2;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	si->Lock();
	*p1 = si->tcp.r->Size();
	si->Unlock();
	return 0;
}


// TCP\PbgCount(s)
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpqueue(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	SOCKETINFO *si = (SOCKETINFO *)p2;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	si->Lock();
	*p1 = si->tcp.s->Size();
	si->Unlock();
	return 0;
}


// TCP\PbgWrite
//		p1	
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpput(BMSCR *bm, char *p1, int p2, int p3)
{
	return tcpsend(p1, 0, strlen(p1), p2);
}
// TCP\PbgRead
//		p1	i[ϐ
//		p2  ϐ̃TCY
//		p3	\Pbgnh
EXPORT BOOL WINAPI tcpget(char *p1, int p2, int p3, int p4)
{
	/*  `FbN  */
	if (p2 < 0) return 0;

	BOOL ret = tcprecv(p1, 0, p2-1, p3);
	if (ret > 0) return ret;
	p1[-ret] = '\0';
	return ret;
}


// TCP\PbgWrite(c/w/d)
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpputc(int p1, int p2, int p3, int p4)
{
	return tcpsend((char *)&p1, 0, 1, p2);
}
EXPORT BOOL WINAPI tcpputw(int p1, int p2, int p3, int p4)
{
	return tcpsend((char *)&p1, 0, 2, p2);
}
EXPORT BOOL WINAPI tcpputd(int p1, int p2, int p3, int p4)
{
	return tcpsend((char *)&p1, 0, 4, p2);
}


// TCP\PbgRead(c/w/d)
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpgetc(int *p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;	// \Pbg
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 1) return -1;
	tcprecv((char *)p1, 0, 1, p2);
	return 0;
}
EXPORT BOOL WINAPI tcpgetw(int *p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;	// \Pbg
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 2) return -1;
	tcprecv((char *)p1, 0, 2, p2);
	return 0;
}
EXPORT BOOL WINAPI tcpgetd(int *p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;	// \Pbg
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 4) return -1;
	tcprecv((char *)p1, 0, 4, p2);
	return 0;
}


// TCP\PbgPeek(c/w/d)
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcppeekc(int *p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;	// \Pbg
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 1) return -1;
	tcppeek((char *)p1, 0, 1, p2);
	return 0;
}
EXPORT BOOL WINAPI tcppeekw(int *p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;	// \Pbg
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 2) return -1;
	tcppeek((char *)p1, 0, 2, p2);
	return 0;
}
EXPORT BOOL WINAPI tcppeekd(int *p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p2, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;	// \Pbg
	*p1 = 0;
	int len;
	tcpcount(&len, p2, 0, 0);
	if (len < 4) return -1;
	tcppeek((char *)p1, 0, 4, p2);
	return 0;
}


// sM
//		p1	Mϐ
//		p2	őMTCY
//		p3	\Pbgnh
EXPORT BOOL WINAPI tcpgetl(char *p1, int p2, int p3, int p4)
{
	*p1 = '\0';
	SOCKETINFO *si = (SOCKETINFO *)p3;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return 0;	// \Pbg

	/*  `FbN  */
	if (p2 < 0) return 0;
	if (p2 == 0) p2 = 64;

	int len;
	char *buf;
	int i, ret;
	BOOL bLineCut = FALSE;

	si->Lock();

	len = si->tcp.r->Size();
	if (len == 0) {
		si->Unlock();
		return 0;
	}
	if (len > MAX_LINELEN)
		len = MAX_LINELEN;
	buf = new char[len+1];
	si->tcp.r->Peek(buf, len);
	buf[len] = '\0';

	ret=0;
	for(i=0; i<(int)len; i++) {
		if ( buf[i]==0x0d && buf[i+1]==0x0a ) {
			ret = i+2;
			break;
		}
		if ( buf[i] == 0x0a || buf[i] == 0x00 ) {
			ret = i+1;
			break;
		}
		if ( buf[i] == 0x0d ) {
			if ( i != len-1 || (si->err != 0 && si->err != WSAESHUTDOWN) ) {
				ret = i+1;
				break;
			}
		}
	}

	if (i == MAX_LINELEN) {
		ret = MAX_LINELEN;
		bLineCut = TRUE;
	}
	if (ret == 0 && len > 0 && (si->err != 0 && si->err != WSAESHUTDOWN)) {
		ret = i = len;
	}

	if (ret > 0) {
		si->tcp.r->Read(NULL, ret);
		if (si->tcp.bLineCut) {
			ret = 0;
		}
		else {
			if (i >= p2) i = p2-1;
			memcpy(p1, buf, i);
			p1[i] = '\0';
		}
		si->tcp.bLineCut = bLineCut;
	}

	delete [] buf;

	si->Unlock();
	return -ret;
}




// TCP\Pbg̏擾
//		p1	ϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpinfo(char *p1, int p2, int p3, int p4)
{
	*p1 = '\0';
	SOCKETINFO *si = (SOCKETINFO *)p2;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	char s[128];
	DWORD dw;

	si->Lock();
	dw = sizeof(s);
	if (WSAAddressToString((struct sockaddr *)&si->addr, si->addrlen, NULL, s, &dw) != SOCKET_ERROR)
		strcpy(p1, s);
	si->Unlock();
	return 0;
}



// TCP\PbgLocalPort擾
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpport(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	SOCKETINFO *si = (SOCKETINFO *)p2;
	if (! IsSocket(si, ST_TCPLIS))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	struct sockaddr_storage addr;
	int len = sizeof(addr);

	si->Lock();
	getsockname(si->soc[0], (struct sockaddr *)&addr, &len);
	*p1 = (int)ntohs(((struct sockaddr_in *)&addr)->sin_port);
	si->Unlock();
	return 0;
}



// TCP\PbgBlockingԂ擾
//		p1	\Pbgnh
EXPORT BOOL WINAPI tcpexceed(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;	// \Pbg

	BOOL bBlocking;

	si->Lock();
	bBlocking = si->tcp.bBlocking;
	si->Unlock();

	return bBlocking ? -1 : 0;
}


// TCP\Pbgshutdown
//		p1	\Pbgnh
EXPORT BOOL WINAPI tcpshut(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	si->Lock();
	si->tcp.bShutting = TRUE;
	si->Unlock();
	PostMessage(si->hWnd, WM_PCBNET_SENDING, 0, 0);
	return 0;
}





// TCP\Pbgdiscard
//		p1	TCY
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpdisc(int p1, int p2, int p3, int p4)
{
	int n;
	SOCKETINFO *si = (SOCKETINFO *)p2;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return 0;	// \Pbg

	/*  `FbN  */
	if (p1 < 0) return 0;

	si->Lock();
	n = si->tcp.r->Read(NULL, p1);
	if (si->tcp.bReadPending)
		PostMessage(si->hWnd, WM_PCBNET_ASYNC, (WPARAM)si->soc[0], WSAMAKESELECTREPLY(FD_READ, 0));
	si->Unlock();
	return -n;
}




// TCP\Pbg̑M~
//		p1	\Pbgnh
EXPORT BOOL WINAPI tcplock(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	si->Lock();
	si->tcp.bSending = FALSE;
	si->Unlock();
	PostMessage(si->hWnd, WM_PCBNET_SENDING, 0, 0);
	return 0;
}




// TCP\Pbg̑MJn
//		p1	\Pbgnh
EXPORT BOOL WINAPI tcpunlock(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_TCP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	si->Lock();
	si->tcp.bSending = TRUE;
	si->Unlock();
	PostMessage(si->hWnd, WM_PCBNET_SENDING, 0, 0);
	return 0;
}








////////////////////////////////////////////////////////////////////////////////


// TCP\Pbg쐬Aڑҋ@
//		p1	\Pbgnhi[ϐ
//		p2	|[g
EXPORT BOOL WINAPI tcpmake(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	if (! bInit) return -1;			// WinSockG[

	/*  `FbN  */
	if (p2 < 0 || p2 >= 65536) return -2;	// |[gԍ͈͊O

	SOCKETINFO *si;
	si = CreateSocket(ST_TCPLIS);
	if (si == NULL)
		return -3;			//	SocketG[

	if ( SendMessage(si->hWnd, WM_PCBNET_BIND, (WPARAM)p2, 0) != 0 ) {
		DeleteSocket(si);
		return -4;	// BindɎs
	}

	*p1 = (int)si;
	return 0;
}


// TCPLISTEN\PbgɐڑvĂ邩H
//		p1	\Pbgnh
EXPORT BOOL WINAPI tcpwait(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_TCPLIS))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;	// \Pbg

	int i;
	for(i=0; i<si->socs; i++) {
		if (si->tcplis.bIncoming[i]) break;
	}
	return i < si->socs ? -1 : 0;
}


// TCPLISTEN\PbgŐڑ
//		p1	\Pbgnhi[ϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI tcpaccept(int *p1, int p2, int p3, char *refstr)
{
	*p1 = 0;
	refstr[0] = '\0';
	SOCKETINFO *si = (SOCKETINFO *)p2;
	if (! IsSocket(si, ST_TCPLIS))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	SOCKETPAIR sp;
	SOCKETINFO *si2;
	char s[128];
	DWORD dw;
	int i;

	for(i=0; i<si->socs; i++) {
		if (si->tcplis.bIncoming[i]) break;
	}
	if (i == si->socs) return -2;	// ڑĂȂ

	if (SendMessage(si->hWnd, WM_PCBNET_ACCEPT, 0, (LPARAM)&sp))
		return -4;	// accepts

	si2 = CreateSocket(ST_TCP);
	if (si2 == NULL) {
		closesocket(sp.soc);
		return -3;	// \Pbg̍쐬s
	}

	SendMessage(si2->hWnd, WM_PCBNET_SOCKATTACH, 0, (LPARAM)&sp);

	dw = sizeof(s);
	if (WSAAddressToString((struct sockaddr *)&sp.addr, sp.addrlen, NULL, s, &dw) != SOCKET_ERROR)
		strcpy(refstr, s);

	*p1 = (int)si2;
	return 0;
}





EXPORT BOOL WINAPI tcpclose(int p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p1, ST_TCPALL))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;
	return netclose(p1, p2, p3, p4);
}
EXPORT BOOL WINAPI tcperror(int *p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p2, ST_TCPALL))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;
	return neterror(p1, p2, p3, p4);
}
EXPORT BOOL WINAPI tcpfail(int p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p1, ST_TCPALL))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;
	return netfail(p1, p2, p3, p4);
}





