// Original code by TAKAHASHI Shuhei <pcb@pcbsoft.net>
// This code is licensed under NYSL ver. 0.9982.
// See LICENSE.txt for details.

#include "common.h"
#include "general.h"


// UDP\Pbg쐬Aڑ
//		p1	\Pbgnhi[ϐ
//		p2	BIND|[g
//		p3	LtO
EXPORT BOOL WINAPI udpsock(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	if (! bInit) return -1;		// WinSockG[

	/*  `FbN  */
	if (p2 < 0 || p2 >= 65536) return -4;	// ͈͊O

	SOCKETINFO *si;

	si = CreateSocket(ST_UDP);
	if (si == NULL)
		return -2;			//	SocketG[

	if ( SendMessage(si->hWnd, WM_PCBNET_BIND, (WPARAM)p2, (LPARAM)p3) != 0 ) {
		DeleteSocket(si);
		return -3;			//	BindG[
	}

	*p1 = (int)si;
	return 0;
}


// UDP\Pbg̑Mw肷
//		p1	\Pbgnh
//		p2	MAhX
//		p3	M|[g
EXPORT BOOL WINAPI udpsendto(int p1, char *p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	/*  `FbN  */
	if (p3 <= 0 || p3 >= 65536) return 0;

	SendMessage(si->hWnd, WM_PCBNET_CONNECT, (WPARAM)p3, (LPARAM)p2);

	return 0;
}

// UDP\Pbgڑς݂ǂ擾
//		p1	ԕϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpiscon(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -4;	// \Pbg

	int ret;
	si->Lock();
	if ( si->err != 0 )
		ret = -3;		//	G[
	else if ( si->udp.bSendable )
		ret = -1;		//	ݒς
	else if ( si->udp.bResolved )
		ret = -2;		//	Ɏs
	else
		ret = 0;		//	wor
	si->Unlock();

	return ret;
}



// UDP\PbgCount
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpcount(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;

	SOCKETINFO *si = (SOCKETINFO *)p2;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	si->Lock();
	*p1 = si->udp.r->GetNextLength();
	si->Unlock();
	return 0;
}



// pPbg擾
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpcheck(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	SOCKETINFO *si = (SOCKETINFO *)p2;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	si->Lock();
	*p1 = si->udp.r->Count();
	si->Unlock();
	return 0;
}





// ŌɎMUDPf[^O̔M擾
//		p1	ϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpinfo(char *p1, int p2, int p3, int p4)
{
	*p1 = '\0';
	SOCKETINFO *si = (SOCKETINFO *)p2;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;	// \Pbg

	char s[128];
	int len;

	si->Lock();
	if (si->udp.fromaddr.ss_family == PF_UNSPEC) {
		si->Unlock();
		return -1;	// M
	}
	len = sizeof(s);
	if (WSAAddressToString((struct sockaddr *)&si->udp.fromaddr, si->udp.fromaddrlen, NULL, s, (DWORD *)&len) != SOCKET_ERROR)
		strcpy(p1, s);
	si->Unlock();
	return 0;
}



// UDP\PbgLocalPort擾
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpport(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	SOCKETINFO *si = (SOCKETINFO *)p2;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;	// \Pbg

	struct sockaddr_storage addr;
	int addrlen = sizeof(addr);

	si->Lock();
	getsockname(si->soc[0], (struct sockaddr *)&addr, &addrlen);
	*p1 = (int)ntohs(((struct sockaddr_in *)&addr)->sin_port);
	si->Unlock();
	return 0;
}



// UDP\PbgBlockingԂ擾
//		p1	\Pbgnh
EXPORT BOOL WINAPI udpsent(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;	// \Pbg

	return si->udp.bBlocking ? 0 : -1;
}



// UDP̍őDatagramTCY擾
//		p1	lϐ
EXPORT BOOL WINAPI udpmax(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	if (! bInit) return -1;	// \Pbg

	*p1 = (int)wsaData.iMaxUdpDg;
	return 0;
}













// UDP\PbgRead
//		p1	ϐ
//		p2	ItZbg
//		p3	őMTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI udprecv(char *p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p4;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	/*  `FbN  */
	if (p2 < 0 || p3 < 0) return 0;

	int n;

	if (si->err != 0) return 0;

	si->Lock();
	n = si->udp.r->Read(p1+p2, (struct sockaddr *)&si->udp.fromaddr, &si->udp.fromaddrlen, p3);
	if (si->udp.bReadPending)
		PostMessage(si->hWnd, WM_PCBNET_ASYNC, 0, WSAMAKESELECTREPLY(FD_READ, 0));
	si->Unlock();
	return -n;
}


// UDP\PbgPeek
//		p1	ϐ
//		p2	ItZbg
//		p3	őMTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI udppeek(char *p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p4;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	/*  `FbN  */
	if (p2 < 0 || p3 < 0) return 0;

	int n;

	if (si->err != 0) return 0;

	si->Lock();
	n = si->udp.r->Peek(p1+p2, (struct sockaddr *)&si->udp.fromaddr, &si->udp.fromaddrlen, p3);
	si->Unlock();
	return -n;
}


// UDP\PbgWrite
//		p1	ϐ
//		p2	ItZbg
//		p3	MTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI udpsend(char *p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p4;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	/*  `FbN  */
	if (p2 < 0 || p3 < 0) return 0;

	si->Lock();
	if (si->err != 0) {
		si->Unlock();
		return -1;
	}
	if (! si->udp.bSendable) {
		si->Unlock();
		return -2;
	}
	si->udp.s->Write(p1+p2, p3, (struct sockaddr *)&si->addr, si->addrlen);
	PostMessage(si->hWnd, WM_PCBNET_SENDING, 0, 0);
	si->Unlock();
	return 0;
}






// UDP\PbgWrite
//		p1	
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpput(BMSCR *bm, char *p1, int p2, int p3)
{
	return udpsend(p1, 0, strlen(p1), p2);
}
// UDP\PbgRead
//		p1	i[ϐ
//		p2  ϐ̃TCY
//		p3	\Pbgnh
EXPORT BOOL WINAPI udpget(char *p1, int p2, int p3, int p4)
{
	BOOL ret = udprecv(p1, 0, p2-1, p3);
	p1[-ret] = '\0';
	return ret;
}



// }`LXgZbVɎQ
//		p1	\Pbgnh
//		p2	}`LXgAhX
EXPORT BOOL WINAPI udpmjoin(int p1, char *p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	int i, ret;
	ip_mreq mreq4;
	ipv6_mreq mreq6;
	struct sockaddr_in addr4;
	struct sockaddr_in6 addr6;
	struct sockaddr_storage addr;
	int addrlen;
	
	if (addrlen = sizeof(addr4), WSAStringToAddress(p2, AF_INET, NULL, (struct sockaddr *)&addr4, &addrlen) == 0) {
		// IPv4 }`LXg
		if ( ntohl(addr4.sin_addr.s_addr) < 0xE0000000 || ntohl(addr4.sin_addr.s_addr) >= 0xF0000000)
			return -1;
		mreq4.imr_interface.s_addr = htonl(INADDR_ANY);
		mreq4.imr_multiaddr = addr4.sin_addr;
		si->Lock();
		for(i=0; i<si->socs; i++) {
			addrlen = sizeof(addr);
			getsockname(si->soc[i], (struct sockaddr *)&addr, &addrlen);
			if (addr.ss_family == PF_INET) break;
		}
		if (i == si->socs) {
			si->Unlock();
			return -2;
		}
		ret = setsockopt(si->soc[i], IPPROTO_IP, IP_ADD_MEMBERSHIP, (char *)&mreq4, sizeof(mreq4));
		si->Unlock();
	}
	else if ((addrlen = sizeof(addr6), WSAStringToAddress(p2, AF_INET6, NULL, (struct sockaddr *)&addr6, &addrlen) == 0)) {
		// IPv6 }`LXg
		if (IN6_IS_ADDR_MULTICAST(&addr6.sin6_addr) == 0)
			return -1;
		mreq6.ipv6mr_interface = 0;
		mreq6.ipv6mr_multiaddr = addr6.sin6_addr;
		si->Lock();
		for(i=0; i<si->socs; i++) {
			addrlen = sizeof(addr);
			getsockname(si->soc[i], (struct sockaddr *)&addr, &addrlen);
			if (addr.ss_family == PF_INET6) break;
		}
		if (i == si->socs) {
			si->Unlock();
			return -2;
		}
		ret = setsockopt(si->soc[i], IPPROTO_IPV6, IPV6_ADD_MEMBERSHIP, (char *)&mreq6, sizeof(mreq6));
		si->Unlock();
	}
	else {
		return -4;
	}

	if (ret == SOCKET_ERROR) return -3;
	return 0;
}






// }`LXgZbVEނ
//		p1	\Pbgnh
//		p2	}`LXgAhX
EXPORT BOOL WINAPI udpmdrop(int p1, char *p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	int i, ret;
	ip_mreq mreq4;
	ipv6_mreq mreq6;
	struct sockaddr_in addr4;
	struct sockaddr_in6 addr6;
	struct sockaddr_storage addr;
	int addrlen;
	
	if (addrlen = sizeof(addr4), WSAStringToAddress(p2, AF_INET, NULL, (struct sockaddr *)&addr4, &addrlen) == 0) {
		// IPv4 }`LXg
		if ( ntohl(addr4.sin_addr.s_addr) < 0xE0000000 || ntohl(addr4.sin_addr.s_addr) >= 0xF0000000)
			return -1;
		mreq4.imr_interface.s_addr = htonl(INADDR_ANY);
		mreq4.imr_multiaddr = addr4.sin_addr;
		si->Lock();
		for(i=0; i<si->socs; i++) {
			addrlen = sizeof(addr);
			getsockname(si->soc[i], (struct sockaddr *)&addr, &addrlen);
			if (addr.ss_family == PF_INET) break;
		}
		if (i == si->socs) {
			si->Unlock();
			return -2;
		}
		ret = setsockopt(si->soc[i], IPPROTO_IP, IP_DROP_MEMBERSHIP, (char *)&mreq4, sizeof(mreq4));
		si->Unlock();
	}
	else if ((addrlen = sizeof(addr6), WSAStringToAddress(p2, AF_INET6, NULL, (struct sockaddr *)&addr6, &addrlen) == 0)) {
		// IPv6 }`LXg
		if (IN6_IS_ADDR_MULTICAST(&addr6.sin6_addr) == 0)
			return -1;
		mreq6.ipv6mr_interface = 0;
		mreq6.ipv6mr_multiaddr = addr6.sin6_addr;
		si->Lock();
		for(i=0; i<si->socs; i++) {
			addrlen = sizeof(addr);
			getsockname(si->soc[i], (struct sockaddr *)&addr, &addrlen);
			if (addr.ss_family == PF_INET6) break;
		}
		if (i == si->socs) {
			si->Unlock();
			return -2;
		}
		ret = setsockopt(si->soc[i], IPPROTO_IPV6, IPV6_DROP_MEMBERSHIP, (char *)&mreq6, sizeof(mreq6));
		si->Unlock();
	}
	else {
		return -4;
	}

	if (ret == SOCKET_ERROR) return -3;
	return 0;
}





// }`LXgpPbgTTLݒ肷
//		p1	\Pbgnh
//		p2	TTL̒l(1)
EXPORT BOOL WINAPI udpmttl(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	struct sockaddr_storage addr;
	int addrlen;
	int i;

	si->Lock();
	for(i=0; i<si->socs; i++) {
		addrlen = sizeof(addr);
		getsockname(si->soc[i], (struct sockaddr *)&addr, &addrlen);
		if (addr.ss_family == PF_INET)
			setsockopt(si->soc[i], IPPROTO_IP, IP_MULTICAST_TTL, (char *)&p2, sizeof(p2));
		if (addr.ss_family == PF_INET6)
			setsockopt(si->soc[i], IPPROTO_IPV6, IPV6_MULTICAST_HOPS, (char *)&p2, sizeof(p2));
	}
	si->Unlock();

	return 0;
}




// TTLݒ肷
//		p1	\Pbgnh
//		p2	TTL̒l(255)
EXPORT BOOL WINAPI udpttl(int p1, int p2, int p3, int p4)
{
	SOCKETINFO *si = (SOCKETINFO *)p1;
	if (! IsSocket(si, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	struct sockaddr_storage addr;
	int addrlen;
	int i;

	si->Lock();
	for(i=0; i<si->socs; i++) {
		addrlen = sizeof(addr);
		getsockname(si->soc[i], (struct sockaddr *)&addr, &addrlen);
		if (addr.ss_family == PF_INET)
			setsockopt(si->soc[i], IPPROTO_IP, IP_TTL, (char *)&p2, sizeof(p2));
		if (addr.ss_family == PF_INET6)
			setsockopt(si->soc[i], IPPROTO_IPV6, IPV6_UNICAST_HOPS, (char *)&p2, sizeof(p2));
	}
	si->Unlock();

	return 0;
}





EXPORT BOOL WINAPI udpclose(int p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p1, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;
	return netclose(p1, p2, p3, p4);
}
EXPORT BOOL WINAPI udperror(int *p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p2, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;
	return neterror(p1, p2, p3, p4);
}
EXPORT BOOL WINAPI udpfail(int p1, int p2, int p3, int p4)
{
	if (! IsSocket((SOCKETINFO *)p1, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;
	return netfail(p1, p2, p3, p4);
}




